import { Migration } from '@mikro-orm/migrations';

export class Migration20250309144112 extends Migration {

  async up(): Promise<void> {
    this.addSql('create table `activities` (`id` int unsigned not null auto_increment primary key, `user_id` varchar(255) not null, `room_id` int unsigned not null, `activity` varchar(255) not null, `numeric_value` int null, `note_id` int unsigned null, `timestamp` datetime not null) default character set utf8mb4 engine = InnoDB;');
    this.addSql('alter table `activities` add index `activities_room_id_index`(`room_id`);');
    this.addSql('alter table `activities` add index `activities_note_id_index`(`note_id`);');

    this.addSql('alter table `activities` add constraint `activities_room_id_foreign` foreign key (`room_id`) references `rooms` (`id`) on update cascade on delete cascade;');
    this.addSql('alter table `activities` add constraint `activities_note_id_foreign` foreign key (`note_id`) references `notes` (`id`) on update cascade on delete cascade;');

    this.addSql('alter table `rooms` modify `whiteboard_canvas` blob;');
    this.addSql('alter table `rooms` drop `channel_id`;');
  }

  async down(): Promise<void> {
    this.addSql('drop table if exists `activities`;');

    this.addSql('alter table `rooms` add `channel_id` varchar(255) null;');
    this.addSql('alter table `rooms` modify `whiteboard_canvas` varchar(255);');
  }

}
