import { Migration } from '@mikro-orm/migrations';

export class Migration20250319120010 extends Migration {

  async up(): Promise<void> {
    this.addSql('create table `roomSession` (`id` int unsigned not null auto_increment primary key, `room_id` int unsigned not null, `date_opened` datetime not null, `date_closed` datetime not null) default character set utf8mb4 engine = InnoDB;');
    this.addSql('alter table `roomSession` add index `roomSession_room_id_index`(`room_id`);');

    this.addSql('create table `roomSessionUser` (`id` int unsigned not null auto_increment primary key, `room_session_id` int unsigned not null, `user_id` varchar(255) not null, `name` varchar(255) not null) default character set utf8mb4 engine = InnoDB;');
    this.addSql('alter table `roomSessionUser` add index `roomSessionUser_room_session_id_index`(`room_session_id`);');

    this.addSql('create table `sessionPoints` (`id` int unsigned not null auto_increment primary key, `room_session_user_id` int unsigned not null, `audio_points` int not null, `video_points` int not null, `browser_points` int not null, `whiteboard_points` int not null, `note_points` int not null) default character set utf8mb4 engine = InnoDB;');
    this.addSql('alter table `sessionPoints` add index `sessionPoints_room_session_user_id_index`(`room_session_user_id`);');

    this.addSql('alter table `roomSession` add constraint `roomSession_room_id_foreign` foreign key (`room_id`) references `rooms` (`id`) on update cascade;');

    this.addSql('alter table `roomSessionUser` add constraint `roomSessionUser_room_session_id_foreign` foreign key (`room_session_id`) references `roomSession` (`id`) on update cascade;');

    this.addSql('alter table `sessionPoints` add constraint `sessionPoints_room_session_user_id_foreign` foreign key (`room_session_user_id`) references `roomSessionUser` (`id`) on update cascade;');

    this.addSql('alter table `activities` drop foreign key `activities_room_id_foreign`;');

    this.addSql('alter table `activities` drop index `activities_room_id_index`;');
    this.addSql('alter table `activities` change `room_id` `room_session_id` int unsigned not null;');
    this.addSql('alter table `activities` add constraint `activities_room_session_id_foreign` foreign key (`room_session_id`) references `roomSession` (`id`) on update cascade;');
    this.addSql('alter table `activities` add index `activities_room_session_id_index`(`room_session_id`);');
  }

  async down(): Promise<void> {
    this.addSql('alter table `roomSessionUser` drop foreign key `roomSessionUser_room_session_id_foreign`;');

    this.addSql('alter table `activities` drop foreign key `activities_room_session_id_foreign`;');

    this.addSql('alter table `sessionPoints` drop foreign key `sessionPoints_room_session_user_id_foreign`;');

    this.addSql('drop table if exists `roomSession`;');

    this.addSql('drop table if exists `roomSessionUser`;');

    this.addSql('drop table if exists `sessionPoints`;');

    this.addSql('alter table `activities` drop index `activities_room_session_id_index`;');
    this.addSql('alter table `activities` change `room_session_id` `room_id` int unsigned not null;');
    this.addSql('alter table `activities` add constraint `activities_room_id_foreign` foreign key (`room_id`) references `rooms` (`id`) on update cascade on delete cascade;');
    this.addSql('alter table `activities` add index `activities_room_id_index`(`room_id`);');
  }

}
