import { Migration } from '@mikro-orm/migrations';

export class Migration20250326113705 extends Migration {

  async up(): Promise<void> {
    this.addSql('create table `role` (`id` int unsigned not null auto_increment primary key, `role_name` varchar(255) not null, `room_session_user_id` int unsigned not null) default character set utf8mb4 engine = InnoDB;');
    this.addSql('alter table `role` add index `role_room_session_user_id_index`(`room_session_user_id`);');

    this.addSql('create table `mode` (`id` int unsigned not null auto_increment primary key, `mode_name` varchar(255) not null, `room_session_id` int unsigned not null) default character set utf8mb4 engine = InnoDB;');
    this.addSql('alter table `mode` add unique `mode_room_session_id_unique`(`room_session_id`);');

    this.addSql('alter table `role` add constraint `role_room_session_user_id_foreign` foreign key (`room_session_user_id`) references `roomSessionUser` (`id`) on update cascade;');

    this.addSql('alter table `mode` add constraint `mode_room_session_id_foreign` foreign key (`room_session_id`) references `roomSession` (`id`) on update cascade;');
  }

  async down(): Promise<void> {
    this.addSql('drop table if exists `role`;');

    this.addSql('drop table if exists `mode`;');
  }

}
