import { Migration } from '@mikro-orm/migrations';

export class Migration20250330142342 extends Migration {

  async up(): Promise<void> {
    this.addSql('drop table if exists `role`;');

    this.addSql('drop table if exists `mode`;');

    this.addSql('alter table `roomSession` add `mode_name` varchar(255) null;');

    this.addSql('alter table `roomSessionUser` add `role_name` varchar(255) not null;');

    this.addSql('alter table `sessionPoints` modify `audio_points` int not null default 0, modify `video_points` int not null default 0, modify `browser_points` int not null default 0, modify `whiteboard_points` int not null default 0, modify `note_points` int not null default 0;');
    this.addSql('alter table `sessionPoints` add unique `sessionPoints_room_session_user_id_unique`(`room_session_user_id`);');
  }

  async down(): Promise<void> {
    this.addSql('create table `role` (`id` int unsigned not null auto_increment primary key, `role_name` varchar(255) not null, `room_session_user_id` int unsigned not null) default character set utf8mb4 engine = InnoDB;');
    this.addSql('alter table `role` add index `role_room_session_user_id_index`(`room_session_user_id`);');

    this.addSql('create table `mode` (`id` int unsigned not null auto_increment primary key, `mode_name` varchar(255) not null, `room_session_id` int unsigned not null) default character set utf8mb4 engine = InnoDB;');
    this.addSql('alter table `mode` add unique `mode_room_session_id_unique`(`room_session_id`);');

    this.addSql('alter table `role` add constraint `role_room_session_user_id_foreign` foreign key (`room_session_user_id`) references `roomSessionUser` (`id`) on update cascade;');

    this.addSql('alter table `mode` add constraint `mode_room_session_id_foreign` foreign key (`room_session_id`) references `roomSession` (`id`) on update cascade;');

    this.addSql('alter table `roomSession` drop `mode_name`;');

    this.addSql('alter table `roomSessionUser` drop `role_name`;');

    this.addSql('alter table `sessionPoints` modify `audio_points` int not null, modify `video_points` int not null, modify `browser_points` int not null, modify `whiteboard_points` int not null, modify `note_points` int not null;');
    this.addSql('alter table `sessionPoints` drop index `sessionPoints_room_session_user_id_unique`;');
  }

}
