import { Migration } from '@mikro-orm/migrations';

export class Migration20250331133722_modify_session_points_constraint extends Migration {

  async up(): Promise<void> {
    // First drop any duplicate rows, keeping only one
    this.addSql(`
      DELETE s1 FROM sessionPoints s1
      INNER JOIN sessionPoints s2 
      WHERE s1.id > s2.id 
      AND s1.room_session_user_id = s2.room_session_user_id
    `);
  }

  async down(): Promise<void> {
    // No need for down migration as we're just cleaning data
  }
}
