import { Global, Module, forwardRef } from '@nestjs/common';
import { MikroOrmModule } from '@mikro-orm/nestjs';
import { ActivitiesService } from './activities.service';
import { Activity } from './activities.entity';
import { SessionPointsService } from 'src/points/sessionPoints.service';
import { SessionPointsModule } from 'src/points/sessionPoints.module';
import { SessionPoints } from 'src/points/sessionPoints.entity';


/**
 * A global module that encapsulates features related to tracking.
 */
@Global()
@Module({
  imports: [MikroOrmModule.forFeature([Activity, SessionPoints]), 
  forwardRef(() => SessionPointsModule)],
  providers: [ActivitiesService],
  exports: [ActivitiesService],
})
export class ActivitiesModule {}
