import {
    Entity,
    PrimaryKey,
    Property,
    ManyToOne,
  } from '@mikro-orm/core';
  import { RoomSessionUser } from '../room/roomSessionUser.entity';
  
/**
 * Represents a sessionPoints entity.
 */
@Entity({ tableName: 'sessionPoints' })
export class SessionPoints {
    @PrimaryKey()
    id!: number;
    
    @ManyToOne(() => RoomSessionUser, { unique: true })
    roomSessionUser!: RoomSessionUser;

    @Property()
    audioPoints: number;

    @Property()
    videoPoints: number;

    @Property()
    browserPoints: number;

    @Property()
    whiteboardPoints: number;

    @Property()
    notePoints: number;

    @Property()
    eraserPoints: number;

    @Property()
    noteDeletePoints: number;

    constructor(roomSessionUser: RoomSessionUser) {
        this.roomSessionUser = roomSessionUser;
        this.audioPoints = 0;
        this.videoPoints = 0;
        this.browserPoints = 0;
        this.whiteboardPoints = 0;
        this.notePoints = 0;
        this.eraserPoints = 0;
        this.noteDeletePoints = 0;
    }
}