import { forwardRef, Module } from '@nestjs/common';
import { MikroOrmModule } from '@mikro-orm/nestjs';
import { SessionPoints } from './sessionPoints.entity';
import { RoomSessionUser } from '../room/roomSessionUser.entity';
import { RoomSessionUserModule } from '../room/roomSessionUser.module';
import { SessionPointsService } from './sessionPoints.service';

@Module({
    imports: [MikroOrmModule.forFeature([SessionPoints, RoomSessionUser]), 
    forwardRef(() => RoomSessionUserModule)],
    providers: [SessionPointsService],
    exports: [SessionPointsService],
})
export class SessionPointsModule {}