import { Global, Module } from '@nestjs/common';
import { RoomService } from './room.service';
import { RoomController } from './room.controller';
import { MikroOrmModule } from '@mikro-orm/nestjs';
import { Room } from './room.entity';
import { RoomSessionModule } from './roomSession.module';
import { RoomSessionUserModule } from './roomSessionUser.module';

/**
 * Represents a global module for managing rooms.
 */
@Global()
@Module({
  imports: [MikroOrmModule.forFeature([Room]), RoomSessionModule, RoomSessionUserModule],
  providers: [RoomService],
  controllers: [RoomController],
  exports: [RoomService],
})
export class RoomModule {}
