export class RoomSessionResponseDto {
    id: number;
    dateOpened: Date;
    dateClosed?: Date;
    users: {
      id: number;
      userId: string;
      name: string;
    }[];
    roomId: number;
    roomName: string;
    activities: { 
      activity: string;
      timestamp: Date;
      userId: string;
    }[];  
    points: RoomSessionPointsRequestDto;
    sessionId: number;
    mode: RoomSessionModeRequestDto;
  }

export class RoomSessionPointsRequestDto {
    allPositivePoints: {audioPoints: number, videoPoints: number, browserPoints: number, whiteboardPoints: number, notePoints: number};
    allNegativePoints: {eraserPoints: number, noteDeletePoints: number}
    totalPoints: number;
    sessionId: number;
}
export class RoomSessionModeRequestDto {
    modeName: string;
    sessionId: number;
}