import { Module, forwardRef } from '@nestjs/common';
import { MikroOrmModule } from '@mikro-orm/nestjs';
import { RoomSessionService } from './roomSession.service';
import { RoomSession } from './roomSession.entity';
import { RoomSessionPointsController } from './roomSession.controller';
import { RoomSessionUserModule } from './roomSessionUser.module';
import { RoomSessionUser } from './roomSessionUser.entity';
import { SessionPointsModule } from '../points/sessionPoints.module';
import { ActivitiesModule } from '../activities/activities.module';
import { SessionPoints } from '../points/sessionPoints.entity';

@Module({
    imports: [
        MikroOrmModule.forFeature([RoomSession, RoomSessionUser, SessionPoints]), 
        forwardRef(() => RoomSessionUserModule),
        forwardRef(() => SessionPointsModule),
        forwardRef(() => ActivitiesModule),
    ],
    providers: [RoomSessionService],
    controllers: [RoomSessionPointsController],
    exports: [RoomSessionService],
})
export class RoomSessionModule {}